import _classPrivateFieldGet from "@babel/runtime/helpers/esm/classPrivateFieldGet";
import _classPrivateFieldSet from "@babel/runtime/helpers/esm/classPrivateFieldSet";
import { BuilderLink } from "../../core/BuilderLink";
import { ConstLocationComposer } from "../composers/ConstLocationComposer";
import { ConstRouteRecord } from "../RouteRecord/ConstRouteRecord";
import { SingleRouteAbstractBuilder } from "../SingleRouteAbstractBuilder";
import { fillOptions } from "./fillOptions";

var _root = new WeakMap();

var _route = new WeakMap();

var _link = new WeakMap();

export class RootRouteBuilder extends SingleRouteAbstractBuilder {
  static init(options = {}) {
    fillOptions(options);
    const link = new BuilderLink({
      composer: new ConstLocationComposer(options.root)
    });
    return new RootRouteBuilder(link, options.root);
  }

  constructor(link, root) {
    super();

    _root.set(this, {
      writable: true,
      value: void 0
    });

    _route.set(this, {
      writable: true,
      value: void 0
    });

    _link.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _link, link);

    _classPrivateFieldSet(this, _root, root);

    _classPrivateFieldSet(this, _route, new ConstRouteRecord(this, root, undefined));

    link.register(this, () => {
      const route = _classPrivateFieldGet(this, _route);

      return {
        type: "normal",
        value: route,
        link: route.getAttachedBuilderLink()
      };
    });
  }

  action(action) {
    const root = _classPrivateFieldGet(this, _root);

    const result = new RootRouteBuilder(_classPrivateFieldGet(this, _link).inherit(), root);

    _classPrivateFieldSet(result, _route, new ConstRouteRecord(result, root, action));

    return result;
  }

  getRoute() {
    return _classPrivateFieldGet(this, _route);
  }

  getBuilderLink() {
    return _classPrivateFieldGet(this, _link);
  }

}