import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _classPrivateFieldGet from "@babel/runtime/helpers/esm/classPrivateFieldGet";
import _classPrivateFieldSet from "@babel/runtime/helpers/esm/classPrivateFieldSet";
import { routeRecordParentKey, routeRecordSegmentGetterKey } from "../symbols";
const defaultRoot = {
  pathname: "/",
  state: null
};
/**
 * Object for each route provided by RouteBuilder.
 * Should implement RouteRecordType.
 */

var _builder = new WeakMap();

export class RouteRecordBase {
  /**
   * Action of this route.
   */
  constructor(parentLink, action, segmentGetter) {
    _defineProperty(this, "action", void 0);

    _defineProperty(this, routeRecordParentKey, void 0);

    _builder.set(this, {
      writable: true,
      value: undefined
    });

    _defineProperty(this, routeRecordSegmentGetterKey, void 0);

    _defineProperty(this, "attach", void 0);

    this.action = action;
    this[routeRecordSegmentGetterKey] = segmentGetter;
    Object.defineProperty(this, routeRecordParentKey, {
      value: parentLink
    });
    Object.defineProperty(this, "attach", {
      configurable: true,
      writable: true,

      value(builder) {
        const link = builder.getBuilderLink().getAttachmentRoot();

        _classPrivateFieldSet(this, _builder, link);

        link.attachToParent(parentLink, segmentGetter);
        return builder;
      }

    });
  }
  /**
   * Get the link attached to this Route.
   */


  getAttachedBuilderLink() {
    return _classPrivateFieldGet(this, _builder);
  }
  /**
   * Attach given builder as a child of this route.
   */


}